//SRC = $(TARGET).c glcd.c ks0108.c user.c
#include "user.h"

#define adc_oe			PG4
#define sram_we			PG0
#define sram_oe			PG1

#define set_f_sel		PD4
#define clr_f_sel		PD5

//#define set_d_sync_trg	PD6
//#define clr_d_sync_trg	PD7

#define inp_clk_mcu		PG3

//#define	set_att			PB3
//#define clr_att			PB2

#define fr_sel			PB0
#define run 			PG2
#define a_d_sync		PB5

#define on	1
#define off	0
//-----------------------------------------

#define A_sel		PB1
#define B_sel		PB2
#define C_sel		PB3
//---------------------------------------


void avr_init(void);

inline void gird (void);
void axis (void);


//     
void att_sel(unsigned char d);
void freq_div_sel(unsigned char f_d);
void set_dig_sync_level(unsigned char l);

//   
void run_osc (void);
void mcu_clk_imp(void);

void sync_type_ind (unsigned char a);
void sync_type_tn (unsigned char a);

//void sync_sel_ind (unsigned char a);

//      
unsigned char max_arr(unsigned char arr[]);
unsigned char min_arr(unsigned char arr[]);
unsigned char av_arr(unsigned char arr[]);
unsigned char get_fr (unsigned char arr[]);


unsigned char f_div=0;
unsigned char v_div=2;
int sin_l=0;

unsigned char k_o,k_f,k_sync;

unsigned char oldkey=0b11111000;//   

volatile unsigned char SRAM_i,i_razv,i_del;

unsigned char tmp_max,tmp_min,tmp_sinc=0;//, ,  

unsigned char adc_array[0xff];
//unsigned char adc_array_ext_1[0xff],adc_array_ext_2[0xff];
unsigned char adc_array_tmp[0xff];

//unsigned char U_0,U_m_dc,U_m_ac=0;
unsigned int Um_acc=0;

unsigned char adc_res_tmp,adc_res,temp_v;

inline void fr_div_ind (unsigned char _val);
//inline void v_div_ind (unsigned char _val);


ISR(INT1_vect) // 
{
	TIMSK|=_BV(TOIE2);
	return;
}

ISR(INT0_vect) //     
{
	TIMSK&=~_BV(TOIE2);
	
	EIMSK&=~_BV(INT1);
	EIMSK&=~_BV(INT0);
	
	PORTB|=_BV(fr_sel);
	
	PORTG|=_BV(adc_oe);
	PORTG|=_BV(sram_we);
	PORTG&=~_BV(sram_oe);
	
	
	gird();
	axis ();
	run_osc();
	
	tmp_max=0x00;
	tmp_min=0xff;
	//   
	for (SRAM_i=0;SRAM_i<0xff;SRAM_i++)
	{
		adc_array[SRAM_i]= ((((0xff-ConvData())*10)/48)+1);
		if(tmp_max<adc_array[SRAM_i])	tmp_max=adc_array[SRAM_i];
		if(tmp_min>adc_array[SRAM_i])	tmp_min=adc_array[SRAM_i];			
		mcu_clk_imp();
	}	

	tmp_max=tmp_max-tmp_min;


	if (sin_l == 0)
	{	
	for (tmp_sinc=5;tmp_sinc<0x126;tmp_sinc++)
		{
		if (adc_array[tmp_sinc]<=tmp_max) break;
		}
	if (tmp_sinc<120)
		{
		for (tmp_sinc=tmp_sinc;tmp_sinc<0x126;tmp_sinc++)
			{
			if (adc_array[tmp_sinc]>tmp_max) 
				{
				tmp_sinc=tmp_sinc-2;
				break;
				}
			}	
		}
			if (tmp_sinc > 124) tmp_sinc=5;	
	}
	
	if (sin_l == 1)
	{
	for (tmp_sinc=5;tmp_sinc<0x126;tmp_sinc++)
		{	
		if (adc_array[tmp_sinc]>=tmp_max) break;
		}	
	if (tmp_sinc<120)
		{		
		for (tmp_sinc=tmp_sinc;tmp_sinc<0x126;tmp_sinc++)
			{	
			if (adc_array[tmp_sinc]<tmp_max) 
				{
				tmp_sinc=tmp_sinc-2;
				break;
				}
			}
		}
			if (tmp_sinc > 124) tmp_sinc=5;			
	}

	// 
/*	for (unsigned char i=0;i<0xff;i++)
	{
		adc_array[i]=(adc_array[i]+adc_array[i+1])/2;
	}
	
	for (unsigned char i=0;i<0xff;i++)
	{
		adc_array_ext_2[i]=(adc_array[i]+adc_array[i+1])/2;
	}*/
	
	
	
	//  
	for(i_razv=127;i_razv>0;i_razv--) //  
	{
		glcdClearDot(i_razv,adc_array_tmp[i_razv]);
	if (adc_array_tmp[i_razv] != 0x01) glcdClearDot(i_razv,(adc_array_tmp[i_razv]-1));
		
		adc_array_tmp[i_razv] = adc_array[i_razv+tmp_sinc];
		pause(10);
	}
	
	for(i_razv=0;i_razv<127;i_razv++) //  
	{
		glcdSetDot(i_razv,adc_array[i_razv+tmp_sinc]);
	if (adc_array[i_razv+tmp_sinc] != 0x01) glcdSetDot(i_razv,(adc_array[i_razv+tmp_sinc]-1));		
		pause(10);
	}
	
	
	//   
	
	//for(i_razv=0;i_razv<127;i_razv=i_razv+2) //  
	//{
	//	glcdClearDot(i_razv,(((0xff-adc_res_tmp)*10)/56)-1);
	//	pause(10);
	//}
	
	//adc_res_tmp=adc_res;
	
	//for(i_razv=0;i_razv<127;i_razv=i_razv+2) //  
	//{
	//	glcdSetDot(i_razv,(((0xff-adc_res)*10)/56)-1);
	//	pause(10);
	//}
	
	EIMSK&=~_BV(INT1);
	EIMSK&=~_BV(INT0);		

	return;
}


ISR(TIMER2_OVF_vect)	//""     SRAM
{
		TIMSK&=~_BV(TOIE2);
		EIMSK&=~_BV(INT0);
		
		PORTB&=~_BV(fr_sel);
		
		PORTG|=_BV(sram_oe);
		PORTG&=~_BV(sram_we);
		PORTG&=~_BV(adc_oe);

		
		run_osc();
		
		pause(300); //   !!!!
		
		EIMSK|=_BV(INT0);
		EIMSK&=~_BV(INT1);	
		
	return;	
}

int main (void) 

{	
	avr_init();
	glcdInit(); // GLCD
	glcdClearScreen(); // 		
	
/*	screen_saver (wallpaper);

	for (unsigned char i=0; i<20; i=i++)
	{
		for (unsigned char j=0; j<100; j=j++)
		{
		pause(5000);
		}
	}
	
	glcdClearScreen(); // 		
*/	
	
	axis();// 
	gird();// 
	
	//
	glcdSetAddress(26,LINE8);
	glcdPutStr("v/d");
	glcdSetAddress(109,LINE8);
	glcdPutStr("s/d");
	
	
	freq_div_sel(k_f=2);
//	glcdDigIndication_LINE8_2dig(2,k_f);
	fr_div_ind (k_f);
	
	att_sel(k_o=4);
//	v_div_ind (k_o); 
//	glcdDigIndication_LINE7_2dig(2,k_o);
	
//	set_dig_sync_level(res_ADC());
	
	sync_type_ind (k_sync=2);
	sync_type_tn (k_sync=2);
	
//	sync_sel_ind (2);
	
	sei();
	
	TIMSK|=_BV(TOIE2);
	
	for(;;)
	{
			if (keyE()!=oldkey)	
		{
		cli();
			if (keyE()==0b11101000) //PE4
			{
			k_o++;
			if (k_o>5)	k_o=5;
			att_sel(k_o);

			}
		
			if (keyE()==0b11110000) //PE3
			{
			k_o--;
			if (k_o>5)	k_o=0;
			att_sel(k_o);

			}
		
			if (keyE()==0b11011000) //PE5
			{
			k_f++;
			if (k_f>15)	k_f=15;
			freq_div_sel(k_f);
			fr_div_ind (k_f);

			}
		
			if (keyE()==0b10111000) //PE6
			{
			k_f--;
			if (k_f>15)	k_f=0;
			freq_div_sel(k_f);
			fr_div_ind (k_f);

			}
		
			if (keyE()==0b01111000) //PE7
			{
			k_sync++;
			if (k_sync>2)	k_sync=0;
			//  
			sync_type_ind (k_sync);

			}
//			sync_type_tn (k_sync);

			oldkey=keyE();
		sei();
		}
		sync_type_tn (k_sync);
	}
}
void avr_init (void)
{
//----------------------------------------------------

//   KS107
	PORTA=0x00;
	DDRA=0xff;

//   
	PORTF=0x00;
	DDRF=0b01111110;


	PORTB=0b11000000;
	DDRB= 0b00011111;

// 
	PORTE=0b11111111;
	DDRE= 0b00000000;

//
	PORTC=0x00;
	DDRC= 0x00;
	
//  

	PORTD=0b00000000;
	DDRD= 0b11111100;
	
	PORTG=0b10011;
	DDRG= 0b11111;


//-----------------------------------------------------
// 1    

	//TCCR1A=0b10000001;
	//TCCR1B=0b00001001;
	
	//  
	//OCR1A=1;
//----------------------------------------------------
// 
	EIMSK=0;
	EICRA=0b00000000;
	EICRB=0;

//-----------------------------------------------------
// T2

	TCCR2=0b00000101; //    SRAM
//------------------------------------------------------
//-----------------------------------------------------
// T0
//  

//	TCCR0=0b01101001; 
//	OCR0=0x1f; // 
//------------------------------------------------------
//  
	
//	ADMUX &= 0x7F & 0xF1; ADMUX |= 0x40 | 0x07| 0x20;   

//	ADCSRA &= 0xFB; ADCSRA |= 0x80 | 0x00 | 0x20 | 0x03; 
	
//	ADCSRA |= 0x40;
}

inline void gird (void)
{
	//glcdRectangle(0, 0, 64, 96);
	for (unsigned char i=0; i<128; i=i+4)
	{
		glcdSetDot(i, 28);
	}
		glcdSetDot(64, 27);	
		glcdSetDot(64, 29);	
	
	for (unsigned char i=1; i<128; i=i+3)///// 
	{
		glcdSetDot(i, 4);
	}
		
		for (unsigned char i=0; i<56; i=i+4)
	{
		glcdSetDot(64, i);
	}
		glcdSetDot(63, 28);	
		glcdSetDot(65, 28);	
	
		for (unsigned char i=1; i<128; i=i+3)///// 
	{
		glcdSetDot(i, 52);
	}
	
	
	for (unsigned char j=0;j<128;j=j+8)
	{
		for (unsigned char i=12; i<45; i=i+8)
		{
			glcdSetDot(j, i);
		}
	}
}
void sync_type_ind (unsigned char a)
{
	switch(a)	
	{
		case 0:	//  
			glcdSetAddress(59,LINE8);
			glcdPutStr("");
			sin_l=2;
			break;
		case 1:	//  
			glcdSetAddress(59,LINE8);
			glcdPutStr("");
			sin_l=1;
			break;
		case 2:	//  .
			glcdSetAddress(59,LINE8);
			glcdPutStr("");
			sin_l=0;
			break;
		default:
			break;
	}
	return;
}
void sync_type_tn (unsigned char a)
{
	switch(a)	
	{
		case 0:	//  
//			PORTB|=_BV(a_d_sync);
			EIMSK|=_BV(INT1);
			break;
		case 1:	//  
//			PORTB&=~_BV(a_d_sync);
			TIMSK|=_BV(TOIE2);
			break;
		case 2:	//  .
//			PORTB|=_BV(a_d_sync);
			TIMSK|=_BV(TOIE2);
			break;
		default:
			break;
	}
	return;
}


void run_osc (void)
{
	PORTG&=~_BV(run);
	PORTG|=_BV(run);
	pause(1);
	PORTG&=~_BV(run);
	pause(1);
	return;
}

void mcu_clk_imp(void)
{
	PORTG&=~_BV(inp_clk_mcu	);
	PORTG|=_BV(inp_clk_mcu	);
	pause(1);
	PORTG&=~_BV(inp_clk_mcu	);
	pause(1);
	return;
}

void freq_div_sel(unsigned char f_d)
{
	PORTD&=~_BV(clr_f_sel);
	PORTD|=_BV(clr_f_sel);
	pause(1);
	PORTD&=~_BV(clr_f_sel);
	pause(1);
	
	for (unsigned char c=0;c<f_d;c++)
	{
		PORTD&=~_BV(set_f_sel);
		PORTD|=_BV(set_f_sel);
		pause(2);
		PORTD&=~_BV(set_f_sel);
		pause(2);
	}
	return;
}

inline void att_sel(unsigned char v_d)
{

	switch(v_d)	
	{
		case 0:	
			PORTB&=~_BV(A_sel);
			PORTB&=~_BV(B_sel);
			PORTB&=~_BV(C_sel);
			glcdSetAddress(2,LINE8);
			glcdPutStr(" 50m");
			temp_v=5;
			break;
		case 1:	
			PORTB|=_BV(A_sel);
			PORTB&=~_BV(B_sel);
			PORTB&=~_BV(C_sel);
			glcdSetAddress(2,LINE8);
			glcdPutStr("100m");
			temp_v=1;
			break;
		case 2:		
			PORTB&=~_BV(A_sel);
			PORTB|=_BV(B_sel);
			PORTB&=~_BV(C_sel);
			glcdSetAddress(2,LINE8);
			glcdPutStr("500m");
			temp_v=5;
			break;
		case 3:		
			PORTB|=_BV(A_sel);
			PORTB|=_BV(B_sel);
			PORTB&=~_BV(C_sel);
			glcdSetAddress(2,LINE8);
			glcdPutStr("   1");
			temp_v=1;
			break;
		case 4:		
			PORTB&=~_BV(A_sel);
			PORTB&=~_BV(B_sel);
			PORTB|=_BV(C_sel);
			glcdSetAddress(2,LINE8);
			glcdPutStr("   2");
			temp_v=2;
			break;
		case 5:		
			PORTB|=_BV(A_sel);
			PORTB&=~_BV(B_sel);
			PORTB|=_BV(C_sel);
			glcdSetAddress(2,LINE8);
			glcdPutStr("   5");
			temp_v=5;
			break;
		//case 6:		
		//	PORTB&=~_BV(A_sel);
		//	PORTB|=_BV(B_sel);
		//	PORTB|=_BV(C_sel);
		//	glcdSetAddress(6,LINE7);
		//	glcdPutStr("----");
		//	break;
		//case 7:		
		//	PORTB|=_BV(A_sel);
		//	PORTB|=_BV(B_sel);
		//	PORTB|=_BV(C_sel);
		//	
		//	break;
		default:
		//	PORTB&=~_BV(A_sel);
		//	PORTB&=~_BV(B_sel);
		//	PORTB&=~_BV(C_sel);
			
			break;
	}
	return;
}

void axis (void)
{
// 
	glcdRectangle(0, 0, 56, 128);
	
// 
	//glcdRectangle(0, 56, 7, 1);
	glcdRectangle(56, 56, 7, 1);
	glcdRectangle(72, 56, 7, 1);
//	glcdRectangle(127, 56, 7, 1);
	return;
}

/*void sinc_adr(unsigned char arr)
{ 
	unsigned char i,tmp_;
	tmp_=0;
	for (i=0;i<126;i++)
	{
		if(arr<adc_array[i])	
		{tmp_=i;
		return tmp_;
		}
	}
	return tmp_;
}*/

/*unsigned char max_min(unsigned char arr[])
{ 
	unsigned char tmp_max=adc_array[0],tmp_min=adc_array[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_max<adc_array[i])	tmp_max=adc_array[i];
		if(tmp_min>adc_array[i])	tmp_min=adc_array[i];		
	}
	
	return;
}*/

/*unsigned char max_arr(unsigned char arr[])
{ 
	unsigned char tmp_=arr[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_<arr[i])	tmp_=arr[i];
	}
	return tmp_;
}

unsigned char min_arr(unsigned char arr[])
{ 
	unsigned char tmp_=arr[0],i;
	for (i=0;i<126;i++)
	{
		if(tmp_>arr[i])	tmp_=arr[i];
	}
	return 	tmp_;
}

unsigned char av_arr(unsigned char arr[])
{ 
	unsigned int tmp_=0;
	unsigned char i;
	for (i=0;i<0xff;i++)
	{
		tmp_=tmp_+arr[i];
	}
	tmp_=tmp_/0xff;
	return 46-tmp_;
}

unsigned char get_fr (unsigned char arr[])
{
	unsigned char U_eg=25,i_eg_1=0,i_eg_2=0,i_eg_3=0, i=0;
	
	while ((arr[i]==U_eg)||i==127)	i++;
	i_eg_1=i;
	
	while ((arr[i]==U_eg) ||i==127)	i++;
	i_eg_2=i;
	
	while ((arr[i]==U_eg) ||i==127)	i++;
	i_eg_3=i;

	return i_eg_3-i_eg_1;
	
}*/

inline void fr_div_ind (unsigned char _val)
{
	switch(_val)	
	{
		case 0:	
//			gclcd_put_txt(27,105,"0.275",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("120n");
			break;
		case 1:
//			gclcd_put_txt(27,105,"0.55 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("250n");
			break;
		case 2:
//			gclcd_put_txt(27,105,"1.1  ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("0.5u");
			break;
		case 3:
//			gclcd_put_txt(27,105,"2.2  ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  1u");
			break;
		case 4:
//			gclcd_put_txt(27,105,"4.4  ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  2u");
			break;
		case 5:
//			gclcd_put_txt(27,105,"8.8  ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  4u");
			break;
		case 6:
//			gclcd_put_txt(27,105,"17.6 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  8u");
			break;
		case 7:
//			gclcd_put_txt(27,105,"35.2 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr(" 16u");
			break;
		case 8:
//			gclcd_put_txt(27,105,"70.4 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr(" 32u");
			break;
		case 9:
//			gclcd_put_txt(27,105,"140.8",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr(" 64u");
			break;
		case 10:
//			gclcd_put_txt(27,105,"281.6",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("128u");
			break;
		case 11:
//			gclcd_put_txt(27,105,"563.2",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("256u");
			break;
		case 12:
//			gclcd_put_txt(27,105,"1126 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("0.5m");
			break;
		case 13:
//			gclcd_put_txt(27,105,"2253 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  1m");
			break;
		case 14:
//			gclcd_put_txt(27,105,"4506 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  2m");
			break;
		case 15:
//			gclcd_put_txt(27,105,"9011 ",0);
			glcdSetAddress(85,LINE8);
			glcdPutStr("  4m");
			break;
		default:
			break;
	}
	return;
}

int ConvData(void)
{
 int tmpdat=0;

 if (PINC&0b00000001) tmpdat|=0b10000000;
 if (PINC&0b00000010) tmpdat|=0b01000000;
 if (PINC&0b00000100) tmpdat|=0b00100000;
 if (PINC&0b00001000) tmpdat|=0b00010000;
 if (PINC&0b00010000) tmpdat|=0b00001000;
 if (PINC&0b00100000) tmpdat|=0b00000100;
 if (PINC&0b01000000) tmpdat|=0b00000010;
// if (PINC&0b10000000) tmpdat|=0b00000001;
 return(tmpdat);
}